给定一个数组 candidates 和一个目标数 target ,找出 candidates 所有可以使数字和为 target 的组合。
candidates 中的每个数字在每个组合中只能使用一次。
说明:
所有数字(包括目标数)都是正整数。
解集不能包含重复的组合。
示例 1:
输入: candidates = [10,1,2,7,6,1,5], target = 8,
所求解集为:
[ [1, 7], [1, 2, 5], [2, 6], [1, 1, 6] ]
示例 2:
输入: candidates = [2,5,2,1,2], target = 5,
所求解集为:
[ [1,2,2], [5] ]
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/combination-sum-ii
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
这道题和上一道题的组合求和几乎一模一样,区别在于这题中的数是有重复的数,还有数组中的数只能使用一次。解题的思路还是和上一道题一样,使用回溯法,用一个减法的思路,当residue减到为0的时候,把减过的数添加到结果列表里面。但是同样的思路,这道题要考虑一个数只能使用一次,所以回溯的输入就是当前使用这个数的下一个数,同时还有可能造成产生同一样的结果,所以需要加一条,现存的结果里面有没有刚得到的这个结果,如果没有就加进去。
代码(Java):
public class doingmyself {
public static void main(String[] args) {
int[] candidates = {
10,1,2,7,6,1,5};
int target = 8;
List<List<Integer>> res = new ArrayList<List<Integer>>();
res = combinationSum2(candidates,target);
System.out.println(res);
}
public static List<List<Integer>> combinationSum2(int[] candidates,int target){
List<List<Integer>> res = new ArrayList<List<Integer>>();
int len = candidates.length;
Arrays.sort(candidates);
backrack(candidates,len,target,0,new ArrayList<Integer>(),res);
return res;
}
public static void backrack(int[] candidates,
int len,
int residue,
int begin,
List<Integer> path,
List<List<Integer>> res) {
if(residue == 0) {
//判断现存的结果里面是否存在刚刚得到的这个结果,如果没有,就添加进去
if(!res.contains(new ArrayList<Integer>(path)))
res.add(new ArrayList<Integer>(path));
return;
}
for(int i = begin; i<len;i++) {
if(residue - candidates[i] < 0) {
break;
}
path.add(path.size(),candidates[i]);
backrack(candidates, len, residue-candidates[i], i+1, path, res); //当前是第i个数,下次就要从第i+1个数开始
path.remove(path.size()-1);
}
}
}